#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
@data=();
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$date,$month,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
($bun,$spot,$sun)=split("&",$ENV{QUERY_STRING});
if (!$bun || $spot eq undef || !(-d "$basepath/$bun"))
{
	print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
	print "Location: $adcenter/errclick.html\n\n";
	exit;
}
if (!$sun){$templine="adc2000ng$bun$spot";$sun=$cookie{$templine};}
if ($sun)
{
	$ccuc="adcngbc$sun$spot";
	unless ($cookie{$ccuc})
	{
		$cancount=1;
	}
}
if (!$ENV{HTTP_REFERER} && $logrefererfault && $sun)
{
	open(F,">>$basepath/$sun/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve referer address\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
if (!$ENV{HTTP_USER_AGENT} && $logagentfault && $sun)
{
	open(F,">>$basepath/$sun/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve user agent\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
$templine="adcngacc$sun$spot";
if ($cookie{$templine} && $sun)
{
	($howmany,$fromwhere)=split("#",$cookie{$templine});
	$howmany++;
	$fromwhere.=",$ENV{REMOTE_ADDR}" unless ($fromwhere=~/$ENV{REMOTE_ADDR}/);
	@fromwhere=split(",",$fromwhere);
	$totalfrom=scalar (@fromwhere);
	if ($howmany>$logallowclcperbrowser || $totalfrom>$logallowipperbrowser)
	{
	open(F,">>$basepath/$sun/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tLimit for clicks or IPs per browser is exceed (CLC:$howmany IPS: $totalfrom)\t$fromwhere\n";
	flock(F,$LOCK_UN);
	close(F);
	}
}
else
{
	$howmany=1;
	$fromwhere=$ENV{REMOTE_ADDR};
}

open (FICR,"+<$basepath/credits.db");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
($rat1,$rat2)=split(":",$clickratio);
if ($rat2){$clickratio=$rat1/$rat2;}else{$clickratio=0;}
if ($clickratio=~/\./){$clickratio=substr($clickratio,0,5);}
($imp,$clc)=split(" ",$credit{$bun});
$clc=$clc-1*$compesys[$spot] if ($clc>1*$compesys[$spot]);
$credit{$bun}="$imp $clc";
if ($sun && $cancount)
{
($imp,$clc)=split(" ",$credit{$sun});
if ($enablece){$clc=$clc+$clickratio*$compesys[$spot];}
else {$imp=$imp+$clickratio*$compesys[$spot];}
$credit{$sun}="$imp $clc";
}
truncate(FICR,0);
seek(FICR,0,0);
foreach $key (keys %credit){print FICR "$key\t$credit{$key}\n";}
flock(FICR,$LOCK_UN);
close (FICR);
unless (-e "$basepath/$bun/clicks$spot")
{
	open (F,">$basepath/$bun/clicks$spot");
	flock(F,$LOCK_EX);
	flock(F,$LOCK_UN);
	close (F);
}
open (STAT,"+<$basepath/$bun/clicks$spot");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
open (F,"+<$basepath/$bun/affiliate");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $sun)
	{
		chop($arg4);
		$arg4++;
		$_="$arg1\t$arg2\t$arg3\t$arg4\n";
		$foundflag=1;
		last;
	}
}
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
unless (-e "$basepath/$sun/affilc")
{
	open (F,">$basepath/$sun/affilc");
	flock(F,$LOCK_EX);
	print F "0";
	flock(F,$LOCK_UN);
	close (F);
}
open (F,"+<$basepath/$sun/affilc");
flock(F,$LOCK_EX);
$affilx_data=<F>;
$affilx_data+=1;
truncate(F,0);
seek(F,0,0);
print F $affilx_data;
flock(F,$LOCK_UN);
close (F);

open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
@dt=<F>;
flock(F,$LOCK_UN);
close (F);
foreach (@dt)
{
	($username,$url)=split("\t",$_);
	if ($username eq $bun){$found=1;last;}
}
$url=$furl unless ($found);
($day,$date,$month,$time,$year)=split(" ",scalar gmtime(time+$smartshowdelay*60*60*24));
$month="0$month" if (length($month)==1);
if ($bun ne $yourname)
{
	$tmp_cook="adcngbxshown$spot";
	$cookie{$tmp_cook}.=",$bun";
	$ch_c=1;
}
($dayb,$dateb,$monthb,$timeb,$yearb)=split(" ",scalar gmtime(time+$blocker));
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "set-cookie: adcngacc$sun$spot=$howmany#$fromwhere; \n";
print "set-cookie: adcngbc$sun$spot=1; expires=$dayb, $monthb-$dateb-$yearb $timeb GMT; \n" if ($blocker && $sun && !$cookie{$ccuc});
print "set-cookie: $tmp_cook=$cookie{$tmp_cook}; expires=$day, $month-$date-$year $time GMT; \n" if ($smartshow==2 && $ch_c);
print "Location: $url\n\n";
