#!/usr/bin/perl

#    ADC2000NG - banner exchange perl software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
@data=();
open (F,"<$basepath/domains.db");
flock(F,$LOCK_EX);
@domains=<F>;
flock(F,$LOCK_UN);
close (F);
foreach(@domains)
{
	chop;
	($dom,$dcou)=split("\t",$_);
	$domain{$dom}=$dcou;
}
@userhost=split(/\./,$ENV{REMOTE_HOST});
$ntld=pop(@userhost);
$domain{$ntld}="NOTHING" if (!$domain{$ntld});
$ntld=$domain{$ntld};
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar gmtime(time+$gmtzone*3600));
($hours)=split(":",$time);
if ($hours==0){$hourr=23;}
else {$hourr=$hours-1;}
$lmon=$cal{$month};
$ldte=$date;
$lmon="0".$lmon if (length($lmon)==1);
$ldte="0".$date if (length($date)==1);
$lastact="$year$lmon$ldte";
$time=~s/://g;
open (F,"$basepath/proxy.db");
flock(F,$LOCK_EX);
@proxy=<F>;
flock(F,$LOCK_UN);
close (F);
if (@proxy)
{
$proxy=join("",@proxy);
$proxy=~s/\n/#/g;
$proxy="#$proxy";
$rem_adr=$ENV{REMOTE_ADDR};
$rem_host=$ENV{REMOTE_HOST};
if ($proxy=~/\#$rem_adr\#/ || $proxy=~/\#$rem_host\#/)
{
	print "HTTP/1.0 200 OK\n" if ($sysid eq "Windows");
	print "content-type: application/x-javascript\n\n";
	print qq~ ~;
	exit;
}
}

$user=$ENV{QUERY_STRING};
if (!$user || !(-d "$basepath/$user"))
{
	print "HTTP/1.0 200 OK\n";
	print "content-type: text/html\n\n";
	print qq~document.write(\'<table border=0 cellpadding=0 cellspacing=0><tr><td><font size=2><b>Wrong TX code</b></font></td></tr></table>\')~;
	exit;
}
unless (-e "$basepath/$user/affilx.tx")
{
	open (F,">$basepath/$user/affilx.tx");
	flock(F,$LOCK_EX);
	print F "0";
	flock(F,$LOCK_UN);
	close (F);
}
open (F,"+<$basepath/$user/affilx.tx");
flock(F,$LOCK_EX);
$affilx_data=<F>;
$affilx_data+=1;
truncate(F,0);
seek(F,0,0);
print F $affilx_data;
flock(F,$LOCK_UN);
close (F);
if ($ENV{HTTP_REFERER})
{
	if (-e "$basepath/$user/referer.tx")
	{
		if (-s "$basepath/$user/referer.tx"<100000)
		{
			open(F,"+<$basepath/$user/referer.tx");
			flock(F,$LOCK_EX);
			@refers=<F>;
			foreach(@refers)
			{
				chop;
				($refers,$c_refers)=split("\t",$_);
				$refers{$refers}=$c_refers;
			}
			$refers=$ENV{HTTP_REFERER};
			$refers{$refers}=$refers{$refers}+1;
			truncate(F,0);
			seek(F,0,0);
			foreach $key (keys %refers)
			{
				print F "$key\t$refers{$key}\n";
			}
			flock(F,$LOCK_UN);
			close(F);
		}
	}
	else
	{
		open(F,">$basepath/$user/referer.tx");
		flock(F,$LOCK_EX);
		print F "$ENV{HTTP_REFERER}\t1\n";
		flock(F,$LOCK_UN);
		close(F);
	}
}
if (!$ENV{HTTP_REFERER} && $logrefererfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve referer address\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
if (!$ENV{HTTP_USER_AGENT} && $logagentfault)
{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tCant resolve user agent\t$ENV{REMOTE_ADDR}\n";
	flock(F,$LOCK_UN);
	close(F);
}
$templine="adcngactx$user";
if ($cookie{$templine})
{
	($howmany,$fromwhere)=split("#",$cookie{$templine});
	$howmany++;
	$fromwhere.=",$ENV{REMOTE_ADDR}" unless ($fromwhere=~/$ENV{REMOTE_ADDR}/);
	@fromwhere=split(",",$fromwhere);
	$totalfrom=scalar (@fromwhere);
	if ($howmany>$logallowimpperbrowser || $totalfrom>$logallowipperbrowser)
	{
	open(F,">>$basepath/$user/ca.log");
	flock(F,$LOCK_EX);
	$acdate=scalar gmtime(time+$gmtzone*3600);
	print F "$acdate\tLimit for impressions or IPs per browser is exceed (IMP:$howmany IPS: $totalfrom)\t$fromwhere\n";
	flock(F,$LOCK_UN);
	close(F);
	}
}
else
{
	$howmany=1;
	$fromwhere=$ENV{REMOTE_ADDR};
}


open (F,"<$basepath/$user/target");
flock(F,$LOCK_EX);
@targa=<F>;
flock(F,$LOCK_UN);
close(F);
open (F,">$basepath/$user/lastact");
flock(F,$LOCK_EX);
print F $lastact;
flock(F,$LOCK_UN);
close (F);
open (F,"<$basepath/target.db");
flock(F,$LOCK_EX);
@targets=<F>;
flock(F,$LOCK_UN);
close(F);
foreach(@targets)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$targets{$tusr}=$tval;
}
open (FICR,"+<$basepath/credits.tx");
flock(FICR,$LOCK_EX);
@credits=<FICR>;
foreach(@credits)
{
	chop;
	($tusr,$tval)=split("\t",$_);
	$credit{$tusr}=$tval;
}
open (F, "<$basepath/adcenter.db");
flock(F,$LOCK_EX);
while($line=<F>)
{
	chop($line);
	($username,$url,$usrgroup,$country,$ratio,$referuser,$weight)=split("\t",$line);
	if ($username eq $user)
	{
		$tgroup=$usrgroup;
		$tcountry=$country;
		$userratio=$ratio;
		$refus=$referuser;
		$usersurl=$url;
		next;
	}
	$weight=1 if (!$weight || $weight==0);
	$j=0;
	($imp,$clc)=split(" ",$credit{$username});
	@targs=split("#BETWEENTRG#",$targets{$username});
	$templine_ss="adcngtxshown";
	if ($targa[2]=~/\b$usrgroup\b/ && ($targs[0]=~/\b$tgroup\b/ || !$tgroup) && ($imp>1 || $clc>1 || -e "$basepath/$username/nonexpired") && ($targs[1]=~/\b$tcountry\b/ || $targs[1]=~/\b$ntld\b/ || !$tcountry) && (-s "$adcpath/tx/$username") && !(-e "$basepath/$username/dflag") && (!$smartshow || !($cookie{$templine_ss}=~/\b$username\b/)))
	{
	while ($j<$weight)
	{
		push(@data,$username);
		$j++;
	}
	}
}
flock(F,$LOCK_UN);
close (F);
srand;
$item=int(rand (@data));
$username=$data[$item];
$username=$yourname unless (@data);
($rat1,$rat2)=split(":",$defaultratiotx);
if ($rat2){$defaultratiotx=$rat1/$rat2;}else{$defaultratiotx=0;}
if ($defaultratiotx=~/\./){$defaultratiotx=substr($defaultratiotx,0,5);}
($imp,$clc)=split(" ",$credit{$user});
$imp=$imp+$defaultratiotx;
$credit{$user}="$imp $clc";
($imp,$clc)=split(" ",$credit{$username});
$imp=$imp-1 if ($imp>1);
$credit{$username}="$imp $clc";
if ($refus)
{
($rat1,$rat2)=split(":",$refratio);
if ($rat2){$refratio=$rat1/$rat2;}else{$refratio=0;}
if ($refratio=~/\./){$refratio=substr($refratio,0,5);}
($imp,$clc)=split(" ",$credit{$refus});
$imp=$imp+$refratio;
$credit{$refus}="$imp $clc";
}
truncate(FICR,0);
seek(FICR,0,0);
foreach $key (keys %credit){print FICR "$key\t$credit{$key}\n";}
flock(FICR,$LOCK_UN);
close (FICR);
if ($refus)
{
	unless (-e "$basepath/$refus/referal.tx")
	{
		open (F,">$basepath/$refus/referal.tx");
		flock(F,$LOCK_EX);
		print F "0";
		flock(F,$LOCK_UN);
		close (F);
	}
	open (F,"+<$basepath/$refus/referal.tx");
	flock(F,$LOCK_EX);
	$credit=<F>;
	$credit=$credit+$refratio;
	truncate (F,0);
	seek (F,0,0);
	print F $credit;
	flock(F,$LOCK_UN);
	close(F);
}

unless (-e "$basepath/$username/impressions.tx")
{
	open (F,">$basepath/$username/impressions.tx");
	flock(F,$LOCK_EX);
	flock(F,$LOCK_UN);
	close (F);
}
open (STAT,"+<$basepath/$username/impressions.tx");
flock(STAT,$LOCK_EX);
while($line=<STAT>)
{
	chop($line);
	($tkey,$tval)=split("\t",$line);
	$stats{$tkey}=$tval;
}
@stats=split ("#",$stats{$ldate});
$stats[$hours]=$stats[$hours]+1;
$stats{$ldate}=join("#",@stats[0..23]);
truncate(STAT,0);
seek(STAT,0,0);
foreach $key (keys %stats){print STAT "$key\t$stats{$key}\n";}
flock(STAT,$LOCK_UN);
close (STAT);
if (-e "$basepath/$username/affiliate.tx")
{
open (F,"+<$basepath/$username/affiliate.tx");
flock(F,$LOCK_EX);
@lines=<F>;
foreach (@lines)
{
	($arg1,$arg2,$arg3,$arg4)=split("\t",$_);
	if ($arg1 eq $user)
	{
		$arg3++;
		$_="$arg1\t$arg2\t$arg3\t$arg4";
		$foundflag=1;
		last;
	}
}
push (@lines,"$user\t$usersurl\t1\t0\n") if (!$foundflag);
truncate(F,0);
seek(F,0,0);
print F @lines;
flock(F,$LOCK_UN);
close (F);
}
else
{
open (F,">$basepath/$username/affiliate.tx");
flock(F,$LOCK_EX);
print F "$user\t$usersurl\t1\t0\n";
flock(F,$LOCK_UN);
close (F);
}

open(F,"<$adcpath/tx/$username");
flock(F,$LOCK_EX);
@ads=<F>;
flock(F,$LOCK_UN);
close(F);
srand;
$id=int(rand scalar @ads);
$ad=$ads[$id];
chop($ad);
open (F,"<$basepath/$user/tx.dat");
flock(F,$LOCK_EX);
($bgcol,$fncol,$boxw,$speed)=split("\t",<F>);
flock(F,$LOCK_UN);
close(F);
srand;
$frst=int(rand 10000);
$scnd=int(rand 10000);
($day,$date,$month,$time,$year)=split(" ",scalar gmtime(time+$smartshowdelay*60*60*24));
$month="0$month" if (length($month)==1);
if ($username ne $yourname)
{
	$tmp_cook="adcngtxshown";
	$cookie{$tmp_cook}.=",$username";
	$ch_c=1;
}
print "HTTP/1.0 200 OK\n";
print "P3P: CP=\"UNI\"\n";
print "set-cookie: adcngactx$user=$howmany#$fromwhere; \n";
print "set-cookie: $tmp_cook=$cookie{$tmp_cook}; expires=$day, $month-$date-$year $time GMT; \n" if ($smartshow==1 && $ch_c);
print "content-type: application/x-javascript\n\n";
print qq~
var marqueewidth$frst=$boxw
var marqueeheight$frst=20
var speed$frst=$speed
var marqueecontents$frst='<a href="$cgi/adcrdtx.pl?$username&$user" target="_top"><font color="$fncol" size=3>$ad</font></a>'
var bcolor$frst='#$bgcol'
var bfile$frst='$bgimg'
if (document.all)
document.write('<marquee scrollAmount='+speed$frst+' border=0 bgcolor='+bcolor$frst+' style="width:'+marqueewidth$frst+'">'+marqueecontents$frst+'</marquee>')

function regenerate$frst(){
window.location.reload()
}
function regenerate2$frst(){
if (document.layers){
//tx2=setTimeout("window.onresize=regenerate$frst",450)
intializemarquee$frst()
}
}

function intializemarquee$frst(){
document.cmarquee$frst.document.cmarquee$scnd.document.write('<nobr>'+marqueecontents$frst+'</nobr>')
document.cmarquee$frst.document.cmarquee$scnd.document.close()
thelength$frst=document.cmarquee$frst.document.cmarquee$scnd.document.width
scrollit$frst()
}

function scrollit$frst(){
if (document.cmarquee$frst.document.cmarquee$scnd.left>=thelength$frst*(-1)){
document.cmarquee$frst.document.cmarquee$scnd.left-=speed$frst
tx=setTimeout("scrollit$frst()",100)
}
else{
document.cmarquee$frst.document.cmarquee$scnd.left=marqueewidth$frst
scrollit$frst()
}
}
document.write('<ilayer width='+marqueewidth$frst+' height='+marqueeheight$frst+' name="cmarquee$frst" bgcolor='+bcolor$frst+'>')
document.write('<layer name="cmarquee$scnd"></layer>')
document.write('</ilayer>')
window.onload=regenerate2$frst
~;